const ROOM = window.location.href.split('/')[3];

const mod = io.connect('/mod',{
  query: {
    roomName: ROOM,
  }
});

const tBody = document.querySelector('tbody');

mod.on('leaves data', (leavesData) => {
  console.log(leavesData);
  tBody.innerHTML = '';
  for (socketId in leavesData) {
    const rowData =
      `
      <tr>
      <td>${leavesData[socketId]["userName"]}</td>
      <td><input type="text" id=${socketId} value=${leavesData[socketId]["leafText"] || ''}></td>
      <td>
      <input type="button" onclick="allowUser(this.name); this.remove()" name=${socketId} value="allow user">
      <input type="button" onclick="contentUpdate(this.name)" name=${socketId} value="update text">
      <input type="button" onclick="contentRemove(this.name)" name=${socketId} value="delete text">
      <input type="button" onclick="userRemove(this.name)" name=${socketId} value="delete user">
      </td>
      </tr>
      `;
    tBody.innerHTML += rowData;
  };
});

function allowUser(socketId) {
  mod.emit('allow user', socketId);
}

function contentRemove(socketId){
  mod.emit('leaf delete', socketId);
};

function contentUpdate(socketId){
  const leafData = { leafText: document.getElementById(socketId).value };
  console.log('32', { socketId, leafData });
  mod.emit('leaf update', { socketId, leafData });
};

function userRemove(socketId) {
  mod.emit('user delete', socketId);
};

function savenExit(){
   var d = new Date();
   var filename = d.getTime();
   mod.emit('save exit', filename);
}
