/* @license magnet:?xt=urn:btih:0b31508aeb0634b347b8270c7bee4d411b5d4109&dn=
 * agpl-3.0.txt AGPL-3.0-or-later */

const roomId = window.location.href.split('/')[3];

var socket;
function registerUser() {
  userName = document.getElementById('user-name').value;
  socket = io('/user', {
    query: {
      userName,
      roomId,
    }
  });
  socket.on('connection', document.getElementById('input-fields').innerHTML = '');
  console.log(socket);
  socket.on('leaves data', (leavesData) => {
    let i = 0;
    if (Object.keys(leavesData).length > 0) {
      for(socketId in leavesData) {
        leafData = leavesData[socketId];
        if (leafData.leafText) {
          growLeaves(i, socketId, leafData);
          i++;
        }
      }
    }
  });

  socket.on('leaf delete', (leafId) => {
    const activeLeaf = document.getElementById(leafId);
    activeLeaf.classList.add('leaf-inactive');
    activeLeaf.classList.remove('leaf-active');
    activeLeaf.removeEventListener('click', popupLeaf, false);
    const knowledgeId = activeLeaf.id.replace('path', 'knowledge');
    const leafDataInput = document.getElementById(knowledgeId);
    leafDataInput.outerHTML = "";
  });

  socket.on('enter knowledge', () => {
   document.getElementById("close-button").style.display = "none";
   document.getElementById("knowledge").style.display = "none";
   document.getElementById("tree").style.visibility = "visible";
    const inputField = document.getElementById('input-fields');
    const inputForm =
     `<form id="knowledge-form">
      <input id="knowledge-input" placeholder="Knowledge to preserve" type="text" maxlength="50">
      <input id="knowledge-submit" type="submit" value="Submit" onclick="event.preventDefault(); addKnowledgeItem();">
      <input id="knowledge-edit" type="submit" value="Edit" onclick="event.preventDefault(); editKnowledgeItem();">
      </form>`;
    inputField.innerHTML = inputForm;
  });

  socket.on('delete text', (leafId) => {
     activeLeaf = document.getElementById(leafId);
     activeLeaf.classList.remove("leaf-active");
     activeLeaf.classList.add("leaf-inactive");
     activeLeaf.removeEventListener("click", popupLeaf, false);
     let knowledgeId = leafId.replace("path", "knowledge");
     document.getElementById(knowledgeId).innerHTML = "";
  });
}

function popupLeaf() {
  let knowledgeId = this.id.replace('path', 'knowledge');
  console.log(knowledgeId);
  document.getElementById(knowledgeId).style.display = 'block';
  document.getElementById('knowledge').style.display = 'block';
  document.getElementById('knowledge').style.backgroundImage = 'url("leaf.svg")';
  document.getElementById('knowledge').style.backgroundRepeat = 'no-repeat';
  document.getElementById('knowledge').style.backgroundSize = 'cover';
  if (document.getElementById('tree')){
    document.getElementById('tree').style.visibility = 'hidden';
  }
  if (document.getElementById('knowledge-form')){
    document.getElementById('knowledge-form').style.visibility = 'hidden';
  }
  document.getElementById('close-button').style.display = 'block';
}

function growLeaf(socketId, leafData) {
  const { leafId } = leafData;
  const activeLeaf = document.getElementById(leafId);
  activeLeaf.classList.add('leaf-active');
  activeLeaf.classList.remove('leaf-inactive');
  activeLeaf.addEventListener('click', popupLeaf, false);

  const knowledgeItem = document.createElement('p');
  knowledgeItem.setAttribute('class', 'knowledge-item');
  const knowledgeId = activeLeaf.id.replace('path', 'knowledge');
  const leafDataInput = document.getElementById(knowledgeId);
  if (leafDataInput) {
    leafDataInput.innerHTML = leafData.leafText;
          console.log(socket.id, socketId);
    if (socketId == socket.id) {
      const knowledgeInput = document.getElementById('knowledge-input');
      console.log('32',knowledgeInput);
      knowledgeInput.value   = leafData.leafText;
    }
  } else {
    knowledgeItem.setAttribute('id', knowledgeId);
    knowledgeItem.innerHTML = leafData.leafText;
    document.getElementById('knowledge').appendChild(knowledgeItem);
  }
}

function growLeaves(i, socketId, leafData) {
  setTimeout(() => growLeaf(socketId, leafData), 300 * i);
}

function addKnowledgeItem() {
   leafText = document.getElementById('knowledge-input').value;
   socket.emit("leaf text", leafText);
   document.getElementById("knowledge-input").style.display = "none";
   document.getElementById("knowledge-submit").style.display = "none";
   document.getElementById("knowledge-edit").style.display = "block";
}

function editKnowledgeItem() {
   document.getElementById("knowledge-input").style.display = "block";
   document.getElementById("knowledge-submit").style.display = "block";
   document.getElementById("knowledge-edit").style.display = "none";
}


function closeLeaf() {
   document.getElementById("close-button").style.display = "none";
   document.getElementById("knowledge").style.display = "none";

   let knowledgeItems = document.getElementById("knowledge").children;
   for (let i=0; i<knowledgeItems.length; i++) {
       knowledgeItems[i].style.display = "none";
   }

   document.getElementById("tree").style.visibility = "visible";
   document.getElementById("knowledge-form").style.visibility = "visible";
}

window.onload = function() {
   let activeLeaves = document.getElementsByClassName("leaf-active");
   for(let i=0; i<activeLeaves.length; i++) {
       activeLeaves[i].addEventListener('click', popupLeaf, false);
   }
}

// @license-end
